/*-
 * ~~~~~~licensing~~~~~~
 * profile-management
 * ==========
 * Copyright (C) 2020 - 2021 EmDev LLC
 * ==========
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 *      http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 * ~~~~~~/licensing~~~~~~
 */
package ru.entaxy.esb.platform.core.management.profile.impl.connector;

import javax.management.NotCompliantMBeanException;

import org.osgi.framework.BundleContext;

import ru.entaxy.esb.platform.base.management.core.api.EntaxyRuntimeTyped;
import ru.entaxy.esb.platform.base.management.core.utils.BundleAwareMBeanImpl;
import ru.entaxy.esb.platform.core.management.profile.ConnectorMBean;
import ru.entaxy.esb.platform.core.management.profile.impl.helper.Helpers;

//@TODO move string to constant
@EntaxyRuntimeTyped(name = "entaxy.runtime.connector")
public class ConnectorMBeanImpl extends BundleAwareMBeanImpl<ManagedConnector, ConnectorMBean> implements ConnectorMBean {

	protected Helpers helpers;
	
	public ConnectorMBeanImpl(BundleContext bundleContext, ManagedConnector managedObject, Helpers helpers)
			throws NotCompliantMBeanException {
		super(ConnectorMBean.class, managedObject);
		this.bundleContext = bundleContext;
		this.helpers = helpers;
	}
	
	@Override
	public String getFactoryId() {
		return this.managedObject.getFactoryId();
	}
	
	@Override
	public String getName() {
		return this.managedObject.getName();
	}
	
	@Override
	public String getRegisteredName() {
		return this.managedObject.getRegisteredName();
	}
	
	@Override
	public void start() throws Exception {
		this.helpers.connectorHelper.startConnector(this.managedObject.getSystem(), this.getRegisteredName());
	}
	
	@Override
	public void stop() throws Exception {
		this.helpers.connectorHelper.stopConnector(this.managedObject.getSystem(), this.getRegisteredName());
	}
}
